#include <stdio.h>

typedef union {
    double d;    /* 8 bajtova = 64 bita. */
    int i[2];    /* 2 rijeci od po 4 bajta. */
} Double_bits;


void prikaz_int(int broj)
{
    int nbits, bit, i;
    unsigned mask;

      /* Broj bitova u tipu int. */
    nbits = 8 * sizeof(int);

      /* Pocetna maska ima bit 1
         na najznacajnijem mjestu. */
    mask = 0x1 << nbits - 1;

    for (i = 1; i <= nbits; ++i) {
          /* Maskiranje odgovarajuceg bita. */
        bit = broj & mask ? 1 : 0;
        printf("%d", bit);
        if (i % 4 == 0) printf(" ");
          /* Pomak maske za 1 bit udesno. */
        mask >>= 1;
    }
    printf("\n");

    return;
}

void prikaz_double(double d)
{
    Double_bits u;

    u.d = d;

    printf("   1. rijec: ");
    prikaz_int( u.i[0] );
    printf("   2. rijec: ");
    prikaz_int( u.i[1] );

    return;
}

int main(void)
{
    double x, d;
    int c = 1, i;

    for (i = 0; i < 20; ++i) {
        x = c + 0.1;
        d = 1000 * x;

        printf("\n i = %d, c = %d, (int)(1000*x) = %d\n", i, c, (int)d);

        printf("\n Prikaz broja x = %.3f u racunalu:\n", x);
        prikaz_double(x);

        printf("\n Prikaz broja 1000*x = %.3f u racunalu:\n", d);
        prikaz_double(d);

        c *= 2;
    }

    return 0;
}
