#include <stdio.h>
#include <math.h>
#include "compl.h"

/* ======================================================================== */

    /* Apsolutna vrijednost kompleksnog broja. */

    /* Napomena: cabs vec postoji u <math.h>! */

double zabs(complex a)
{
    return sqrt( a.re * a.re + a.im * a.im );
}

/* ======================================================================== */

    /* Konjugiranje kompleksnog broja. */

complex conjug(complex a)
{
    a.im = -a.im;
    return a;
}

/* ======================================================================== */

    /* Zbrajanje kompleksnih brojeva. */

complex cadd(complex a, complex b)
{
    complex c;
    c.re = a.re + b.re;
    c.im = a.im + b.im;
    return c;
}

/* ======================================================================== */

    /* Oduzimanje kompleksnih brojeva. */

complex csub(complex a, complex b)
{
    complex c;
    c.re = a.re - b.re;
    c.im = a.im - b.im;
    return c;
}

/* ======================================================================== */

    /* Mnozenje kompleksnih brojeva. */

complex cmul(complex a, complex b)
{
    complex c;
    c.re = a.re * b.re - a.im * b.im;
    c.im = a.im * b.re + a.re * b.im;
    return c;
}

/* ======================================================================== */

    /* Dijeljenje kompleksnih brojeva. */

complex cdiv(complex a, complex b)
{
    complex c;
    double naz = zabs(b);
    naz *= naz;  /* kvadriraj */
    c.re = (a.re * b.re + a.im * b.im) / naz;
    c.im = (a.im * b.re - a.re * b.im) / naz;
    return c;

/*     Moze i ovako:
    c = cmul(a, conjug(b)) / naz;
*/
}

/* ======================================================================== */

    /* Ispis kompleksnog broja. */

void cprint(complex a)
{
    printf("(%g, %g)\n", a.re, a.im);
}

/* ======================================================================== */
