#include <stdio.h>
#include <stdlib.h>

    /* Tip za pokazivac na element liste. */

/*  NE SMIJE OVAKO --- element je NEDEFINIRANI TIP:
typedef element *lista;
*/

typedef struct _element *lista;

    /* Tip za element liste. */

typedef struct _element {
    int broj;            /* Sadrzaj je broj. */
    lista sljed;         /* Pokazivac na sljedeci */
} element;               /* element u listi. */

/* ======================================================================== */

lista kreiraj_novi(int broj)
{
    lista novi = NULL;
/*
    if ((novi = (lista) malloc(sizeof(element))) == NULL)
*/
    novi = (lista) malloc(sizeof(element));
    if (novi == NULL) {
        printf("Alokacija nije uspjela.\n");
        exit(-1);
    }

    novi->broj = broj;
    novi->sljed = NULL;

    return novi;
}

/* ======================================================================== */

lista obrisi_element(lista stari)
{
    free(stari);

    return NULL;    /* umjesto stari = NULL; */
}

/* ======================================================================== */

lista ubaci_na_pocetak(lista prvi, lista novi)
{
        /* Ne provjerava novi != NULL. */

    novi->sljed = prvi;
    prvi = novi;

    return prvi;
}

/* ======================================================================== */

lista obrisi_prvog(lista prvi)
{
    lista pom;

    if (prvi != NULL) {
        pom = prvi;
        prvi = prvi->sljed;
        free(pom);
            /* Ne treba pom = NULL; */
    }

    return prvi;
}

/* ======================================================================== */

lista kreiraj_sprijeda(lista prvi, int broj)
{
    lista novi = NULL;
/*
    if ((novi = (lista) malloc(sizeof(element))) == NULL)
*/
    novi = (lista) malloc(sizeof(element));
    if (novi == NULL) {
        printf("Alokacija nije uspjela.\n");
        exit(-1);
    }

    novi->broj = broj;
    novi->sljed = prvi;

        /* Ne treba prvi = novi, vec samo ovo: */
    return novi;
}

/* ======================================================================== */

lista obrisi_listu(lista prvi)
{
    lista pom;
/*
    while (prvi != NULL)
        prvi = obrisi_prvog(prvi);
*/
    while (prvi != NULL) {
        pom = prvi;
        prvi = prvi->sljed;
        free(pom);
    }

    return NULL;    /* <=> return prvi; */
}

/* ======================================================================== */

int broj_elemenata(lista prvi)
{
    lista pom;
    int brojac = 0;

    for (pom = prvi; pom != NULL; pom = pom->sljed)
        ++brojac;

    return brojac;
}

/* ======================================================================== */

void ispisi_listu(lista prvi)
{
    lista pom;
    int brojac = 0;

    for (pom = prvi; pom != NULL; pom = pom->sljed) {
        printf(" Element %2d, broj = %2d\n",
               ++brojac, pom->broj);
    }

    return;
}

/* ======================================================================== */

void ispisi_listu_2(lista prvi)
{
    lista pom;
    int brojac = 0;

    if (prvi == NULL)
        printf(" Lista je prazna!\n");
    else
        for (pom = prvi; pom != NULL; pom = pom->sljed) {
            printf(" Element %2d, broj = %2d\n",
                   ++brojac, pom->broj);
        }

    return;
}

/* ======================================================================== */

lista trazi_broj(lista prvi, int broj)
{
    lista pom = prvi;

    while (pom != NULL && pom->broj != broj)
        pom = pom->sljed;

    return pom;
}

/* ======================================================================== */

lista trazi_zadnji(lista prvi)
{
    lista pom = prvi;

    if (prvi == NULL) return NULL;

    for ( ; pom->sljed != NULL; pom = pom->sljed);

    return pom;
}

/* ======================================================================== */

lista ubaci_iza(lista prvi, lista preth, lista novi)
{
        /* Ne provjerava novi != NULL. */

        /* Ako je preth == NULL,
           ubacujemo na pocetak. */
    if (preth == NULL) {
        novi->sljed = prvi;
        prvi = novi;
    }
    else {
        novi->sljed = preth->sljed;
        preth->sljed = novi;
    }

    return prvi;
}

/* ======================================================================== */

lista obrisi_iza(lista prvi, lista preth)
{
    lista pom;

        /* Ako je preth == NULL,
           brisemo prvi element. */
    if (preth == NULL) {
        pom = prvi;
        prvi = prvi->sljed;
    }
    else {
        pom = preth->sljed;
        preth->sljed = pom->sljed;
    }
    free(pom);
        /* Ne treba pom = NULL; */

    return prvi;
}

/* ======================================================================== */

lista obrisi_iza_pazljivo(lista prvi, lista preth)
{
    lista pom;

    if (prvi == NULL) return NULL;

        /* Ako je preth == NULL,
           brisemo prvi element. */
    if (preth == NULL) {
        pom = prvi;
        prvi = prvi->sljed;
    }
    else {
        pom = preth->sljed;
        if (pom != NULL)
            preth->sljed = pom->sljed;
    }
    free(pom);
        /* Ne treba pom = NULL; */

    return prvi;
}

/* ======================================================================== */

lista ubaci_na_kraj_lose(lista prvi, lista novi)
{
        /* Ne provjerava novi != NULL. */

    lista zadnji;

        /* Moze i samo else blok. */
    if (prvi == NULL)
        prvi = ubaci_na_pocetak(prvi, novi);
    else {
        zadnji = trazi_zadnji(prvi);
        prvi = ubaci_iza(prvi, zadnji, novi);
    }

    return prvi;
}

/* ======================================================================== */

lista ubaci_na_kraj(lista prvi, lista *p_zadnji, lista novi)
{
        /* Ne provjerava novi != NULL. */
        /* Vraca zadnji kroz varijabilni argument. */

    lista zadnji = *p_zadnji;

        /* Ovdje se moze dodati test:
           prvi == NULL || zadnji == NULL. */
    if (prvi == NULL)
        prvi = novi;
    else    /* Ocekujemo zadnji->sljed == NULL. */
        zadnji->sljed = novi;

    novi->sljed = NULL;
    zadnji = novi;
    *p_zadnji = zadnji;  /* Vrati zadnji! */

    return prvi;
}

/* ======================================================================== */

lista kreiraj_straga(lista prvi, lista *p_zadnji, int broj)
{
        /* Vraca zadnji kroz varijabilni argument. */

    lista zadnji = *p_zadnji;
    lista novi = NULL;
/*
    if ((novi = (lista) malloc(sizeof(element))) == NULL)
*/
    novi = (lista) malloc(sizeof(element));
    if (novi == NULL) {
        printf("Alokacija nije uspjela.\n");
        exit(-1);
    }

    novi->broj = broj;
    novi->sljed = NULL;

    if (prvi == NULL)
        prvi = novi;
    else
        zadnji->sljed = novi;

    zadnji = novi;
    *p_zadnji = zadnji;  /* Vrati zadnji! */

    return prvi;
}

/* ======================================================================== */

lista sortirano_ubaci(lista prvi, lista novi)
{
        /* Insertion sort. */
        /* Ne provjerava novi != NULL. */

    lista preth, pom;

/*    Ovo ispod ne treba i jos moze NE RADITI,
      ako nismo sigurni da je novi->sljed == NULL.

    if (prvi == NULL) return novi;
*/

    pom = prvi;
    preth = NULL;    /* Nije nuzno. */

    while (pom != NULL && pom->broj < novi->broj) {
        preth = pom;
        pom = pom->sljed;
    }

        /* Ovo ispod je:
             ubaci_iza(prvi, preth, novi); */
        /* To radi i za prvi == NULL. */
    if (pom == prvi) {
        novi->sljed = prvi;
        prvi = novi;
    }
    else {
        novi->sljed = preth->sljed;
        preth->sljed = novi;
    }

    return prvi;
}

/* ======================================================================== */
