#include <stdio.h>
#include <stdlib.h>

    /* Tip za pokazivac na element liste. */

typedef struct _element *lista;

    /* Tip za element liste. */

typedef struct _element {
    int broj;            /* Sadrzaj je broj. */
    lista sljed;         /* Pokazivac na sljedeci */
} element;               /* element u listi. */

/* ======================================================================== */

lista kreiraj_novi(int broj)
{
    lista novi = NULL;
/*
    if ((novi = (lista) malloc(sizeof(element))) == NULL)
*/
    novi = (lista) malloc(sizeof(element));
    if (novi == NULL) {
        printf("Alokacija nije uspjela.\n");
        exit(-1);
    }

    novi->broj = broj;
    novi->sljed = NULL;

    return novi;
}

/* ======================================================================== */

lista sortirano_ubaci(lista prvi, lista novi)
{
        /* Insertion sort. */
        /* Ne provjerava novi != NULL. */

    lista preth, pom;

/*    Ovo ispod ne treba i jos moze NE RADITI,
      ako nismo sigurni da je novi->sljed == NULL.

    if (prvi == NULL) return novi;
*/

    pom = prvi;
    preth = NULL;    /* Nije nuzno. */

    while (pom != NULL && pom->broj < novi->broj) {
        preth = pom;
        pom = pom->sljed;
    }

        /* Ovo ispod je:
             ubaci_iza(prvi, preth, novi); */
        /* To radi i za prvi == NULL. */
    if (pom == prvi) {
        novi->sljed = prvi;
        prvi = novi;
    }
    else {
        novi->sljed = preth->sljed;
        preth->sljed = novi;
    }

    return prvi;
}

/* ======================================================================== */

lista obrisi_listu(lista prvi)
{
    lista pom;
/*
    while (prvi != NULL)
        prvi = obrisi_prvog(prvi);
*/
    while (prvi != NULL) {
        pom = prvi;
        prvi = prvi->sljed;
        free(pom);
    }

    return NULL;    /* <=> return prvi; */
}

/* ======================================================================== */

int broj_elemenata(lista prvi)
{
    lista pom;
    int brojac = 0;

    for (pom = prvi; pom != NULL; pom = pom->sljed)
        ++brojac;

    return brojac;
}

/* ======================================================================== */

void ispisi_listu(lista prvi)
{
    lista pom;
    int brojac = 0;

    for (pom = prvi; pom != NULL; pom = pom->sljed) {
        printf(" Element %2d, broj = %2d\n",
               ++brojac, pom->broj);
    }

    return;
}

/* ======================================================================== */

int main(void)
{
    lista prvi = NULL;   /* Prazna lista! */
    lista novi;
    int broj;

        /* Sortirano punjenje liste. */

    printf("Upisivati redom brojeve (0 = kraj).\n");
    do {
        printf("Sljedeci broj:\n");
        scanf("%d", &broj);
        printf("\n Ucitao %d\n", broj);
        if (broj != 0) {
            novi = kreiraj_novi(broj);
            prvi = sortirano_ubaci(prvi, novi);
            printf(" Broj elemenata u listi = %d\n",
                   broj_elemenata(prvi));
            ispisi_listu(prvi);
        }
    } while (broj != 0);

        /* Ispis broja elemenata i cijele liste. */

    printf(" Broj elemenata u listi = %d\n",
           broj_elemenata(prvi));
    ispisi_listu(prvi);

        /* Obrisi cijelu listu. */

    prvi = obrisi_listu(prvi);

    return 0;
}
