#include <stdio.h>
#include <stdlib.h>

    /* Tip za pokazivac na element liste. */

typedef struct _element *lista;

    /* Tip za element liste. */

typedef struct _element {
    int broj;            /* Sadrzaj je broj. */
    lista sljed;         /* Pokazivac na sljedeci */
} element;               /* element u listi. */

/* ======================================================================== */

lista kreiraj_straga_rek(lista prvi, int broj)
{
        /* Rekurzivno trazi zadnji. */

    lista novi = NULL;

    if (prvi == NULL) {
        novi = (lista) malloc(sizeof(element));
        if (novi == NULL) {
            printf("Alokacija nije uspjela.\n");
           exit(-1);
        }
        novi->broj = broj;
        novi->sljed = NULL;
        return novi;
    }

    if (prvi->sljed == NULL) {
        novi = (lista) malloc(sizeof(element));
        if (novi == NULL) {
            printf("Alokacija nije uspjela.\n");
            exit(-1);
        }
        novi->broj = broj;
        novi->sljed = NULL;
        prvi->sljed = novi;
    }
    else
        kreiraj_straga_rek(prvi->sljed, broj);
            /* Ne trebamo vrijednost funkcije! */

    return prvi;
}

/* ======================================================================== */

lista merge_rek(lista prvi_1, lista prvi_2)
{
        /* Sortirano spaja dvije liste (merge). */
        /* Rekurzivna varijanta. */

    lista prvi;

    if (prvi_1 == NULL) return prvi_2;
    if (prvi_2 == NULL) return prvi_1;

    if (prvi_1->broj <= prvi_2->broj) {
        prvi = prvi_1;
        prvi->sljed = merge_rek(prvi_1->sljed, prvi_2);
    }
    else {
        prvi = prvi_2;
        prvi->sljed = merge_rek(prvi_1, prvi_2->sljed);
    }

    return prvi;
}

/* ======================================================================== */

lista okreni_listu_rek(lista prvi)
{
        /* Invertira poredak elemenata u listi. */
        /* Rekurzivna varijanta. */

    lista preth, ovaj;

    if (prvi == NULL) return NULL;

    if (prvi->sljed != NULL) {
        preth = prvi;
        ovaj = prvi->sljed;
        prvi = okreni_listu_rek(prvi->sljed);
        ovaj->sljed = preth;
        preth->sljed = NULL;
    }

    return prvi;

}

/* ======================================================================== */

lista obrisi_listu_rek(lista prvi)
{
    if (prvi != NULL) {
        obrisi_listu_rek(prvi->sljed);
/*
    Ne trebamo vrijednost funkcije!
    Mozemo napisati i
        prvi->sljed = obrisi_listu_rek(prvi->sljed);
*/
        free(prvi);
    }

    return NULL;
}

/* ======================================================================== */

int broj_elemenata_rek(lista prvi)
{
    if (prvi == NULL)
        return 0;
    else
        return 1 + broj_elemenata_rek(prvi->sljed);
}

/* ======================================================================== */

void ispisi_listu_rek(lista prvi)
{
    if (prvi == NULL)
        printf(" NULL\n");
    else {
        printf(" %2d -->", prvi->broj);
        ispisi_listu_rek(prvi->sljed);
    }

    return;
}

/* ======================================================================== */

int main(void)
{
    lista prvi_1 = NULL;   /* Prazna lista! */
    lista prvi_2 = NULL;   /* Prazna lista! */
    lista prvi;
    int broj;

        /* Punjenje prve liste straga. */

    printf("Upisivati redom brojeve (0 = kraj).\n");
    do {
        printf("Sljedeci broj:\n");
        scanf("%d", &broj);
        if (broj != 0)
            prvi_1 = kreiraj_straga_rek(prvi_1,
                                        broj);
    } while (broj != 0);

        /* Punjenje drugee liste straga. */

    printf("Upisivati redom brojeve (0 = kraj).\n");
    do {
        printf("Sljedeci broj:\n");
        scanf("%d", &broj);
        if (broj != 0)
            prvi_2 = kreiraj_straga_rek(prvi_2,
                                        broj);
    } while (broj != 0);

        /* Prva lista:
           ispis broja elemenata i cijele liste. */

    printf("\n Prva lista:\n");
    printf(" Broj elemenata u listi = %d\n",
           broj_elemenata_rek(prvi_1));
    ispisi_listu_rek(prvi_1);

        /* Druga lista:
           ispis broja elemenata i cijele liste. */

    printf("\n Druga lista:\n");
    printf(" Broj elemenata u listi = %d\n",
           broj_elemenata_rek(prvi_2));
    ispisi_listu_rek(prvi_2);


        /* Sortirani spoj (merge) dvije liste. */

    prvi = merge_rek(prvi_1, prvi_2);

        /* Spojena lista:
           ispis broja elemenata i cijele liste. */

    printf("\n Spojena lista:\n");
    printf(" Broj elemenata u listi = %d\n",
           broj_elemenata_rek(prvi));
    ispisi_listu_rek(prvi);


        /* Invertiranje liste. */

    prvi = okreni_listu_rek(prvi);

        /* Invertirana lista:
           ispis broja elemenata i cijele liste. */

    printf("\n Invertirana lista:\n");
    printf(" Broj elemenata u listi = %d\n",
           broj_elemenata_rek(prvi));
    ispisi_listu_rek(prvi);

        /* Obrisi cijelu listu. */

    prvi = obrisi_listu_rek(prvi);

    return 0;
}
