#include <stdio.h>
#include <stdlib.h>

    /* Tip za pokazivac na element liste. */

typedef struct _element *lista;

    /* Tip za element liste. */

typedef struct _element {
    int broj;            /* Sadrzaj je broj. */
    lista sljed;         /* Pokazivac na sljedeci */
} element;               /* element u listi. */

/* ======================================================================== */

lista kreiraj_straga(lista prvi, lista *p_zadnji, int broj)
{
        /* Vraca zadnji kroz varijabilni argument. */

    lista zadnji = *p_zadnji;
    lista novi = NULL;
/*
    if ((novi = (lista) malloc(sizeof(element))) == NULL)
*/
    novi = (lista) malloc(sizeof(element));
    if (novi == NULL) {
        printf("Alokacija nije uspjela.\n");
        exit(-1);
    }

    novi->broj = broj;
    novi->sljed = NULL;

    if (prvi == NULL)
        prvi = novi;
    else
        zadnji->sljed = novi;

    zadnji = novi;
    *p_zadnji = zadnji;  /* Vrati zadnji! */

    return prvi;
}

/* ======================================================================== */

int broj_elemenata(lista prvi)
{
    lista pom;
    int brojac = 0;

    for (pom = prvi; pom != NULL; pom = pom->sljed)
        ++brojac;

    return brojac;
}

/* ======================================================================== */

void ispisi_listu_short(lista prvi)
{
    lista pom;

    for (pom = prvi; pom != NULL; pom = pom->sljed) {
        printf(" %2d ->", pom->broj);
    }
    printf(" NULL\n");

    return;
}

/* ======================================================================== */

lista merge(lista prvi_1, lista prvi_2)
{
        /* Sortirano spaja dvije liste (merge). */

    lista prvi = NULL, zadnji, pom;

    if (prvi_1 == NULL) return prvi_2;
    if (prvi_2 == NULL) return prvi_1;

    while (prvi_1 != NULL && prvi_2 != NULL) {
        if (prvi_1->broj <= prvi_2->broj) {
            pom = prvi_1;
            prvi_1 = prvi_1->sljed;
        }
        else {
            pom = prvi_2;
            prvi_2 = prvi_2->sljed;
        }
        if (prvi == NULL)
            prvi = pom;
        else
            zadnji->sljed = pom;
        zadnji = pom;
    }

    if (prvi_1 == NULL)
        zadnji->sljed = prvi_2;

    if (prvi_2 == NULL)
        zadnji->sljed = prvi_1;

    return prvi;
}

/* ======================================================================== */

lista merge_sort_write(lista prvi, int dubina)
{
        /* Sortira listu Merge_Sort algoritmom. */

    lista zadnji, prvi_2;

    printf("\n");
    printf("  Dubina %d, Ulaz:\n", dubina);
    printf("    Ulazna lista - duljina = %d:\n",
           broj_elemenata(prvi));
    printf("        ");
    ispisi_listu_short(prvi);

        /* Test na praznu ili jednoclanu listu. */

    if ((prvi == NULL) || (prvi->sljed == NULL)) {
        printf("  Dubina %d, Izlaz.\n", dubina);
        return prvi;
    }

        /* ``Raspolovi'' listu. Pokazivac zadnji
           pokazuje na zadnjeg u prvom dijelu.
           Pokazivac prvi_2 je trenutno pomocni
           i sluzi za raspolavljanje liste. */

    zadnji = prvi;
    prvi_2 = prvi->sljed;

        /* Pomicemo zadnjeg za JEDNO mjesto,
           a prvi_2 za DVA mjesta, sve dok
           prvi_2 ne stigne do kraja liste. */

    while ((prvi_2 != NULL) &&
           (prvi_2->sljed != NULL)) {

        zadnji = zadnji->sljed;
/* NE VALJA: */
        prvi_2 = zadnji->sljed->sljed;
/*
        prvi_2 = prvi_2->sljed->sljed;
*/
    }

        /* Pokazivac zadnji sad korektno pokazuje
           na zadnjeg u prvom dijelu.
           Pokazivac prvi_2 postavljamo na prvog
           u drugom dijelu (prvi iza zadnjeg) i
           korektno zavrsavamo prvi dio. */

    prvi_2 = zadnji->sljed;
    zadnji->sljed = NULL;

    printf("    Prva lista  - duljina = %d:\n",
           broj_elemenata(prvi));
    printf("        ");
    ispisi_listu_short(prvi);
    printf("    Druga lista - duljina = %d:\n",
           broj_elemenata(prvi_2));
    printf("        ");
    ispisi_listu_short(prvi_2);


    prvi = merge_sort_write(prvi, dubina + 1);
    prvi_2 = merge_sort_write(prvi_2, dubina + 1);


    printf("\n");
    printf("  Dubina %d, Sort:\n", dubina);
    printf("    Sortirana prva lista  - duljina = %d:\n",
           broj_elemenata(prvi));
    printf("        ");
    ispisi_listu_short(prvi);
    printf("    Sortirana druga lista - duljina = %d:\n",
           broj_elemenata(prvi_2));
    printf("        ");
    ispisi_listu_short(prvi_2);


    prvi = merge(prvi, prvi_2);


    printf("    Sortirana spojena lista - duljina = %d:\n",
           broj_elemenata(prvi));
    printf("        ");
    ispisi_listu_short(prvi);
    printf("  Dubina %d, Izlaz.\n", dubina);

    return prvi;
}

/* ======================================================================== */

lista obrisi_listu(lista prvi)
{
    lista pom;
/*
    while (prvi != NULL)
        prvi = obrisi_prvog(prvi);
*/
    while (prvi != NULL) {
        pom = prvi;
        prvi = prvi->sljed;
        free(pom);
    }

    return NULL;    /* <=> return prvi; */
}

/* ======================================================================== */

int main(void)
{
    lista prvi = NULL;   /* Prazna lista! */
    lista zadnji;
    int broj;

        /* Punjenje liste straga. */

    printf("Upisivati redom brojeve (0 = kraj).\n");
    do {
        printf("Sljedeci broj:\n");
        scanf("%d", &broj);
        if (broj != 0)
            prvi = kreiraj_straga(prvi, &zadnji, broj);
    } while (broj != 0);

        /* Ispis broja elemenata i cijele liste. */

    printf("\n Polazna lista:\n");
    printf(" Broj elemenata u listi = %d\n",
           broj_elemenata(prvi));
    ispisi_listu_short(prvi);


        /* Sortiranje liste - mergesort. */

    printf("\n MergeSort liste:\n");
    prvi = merge_sort_write(prvi, 1);

        /* Sortirana lista:
           ispis broja elemenata i cijele liste. */

    printf("\n Sortirana lista:\n");
    printf(" Broj elemenata u listi = %d\n",
           broj_elemenata(prvi));
    ispisi_listu_short(prvi);

        /* Obrisi cijelu listu. */

    prvi = obrisi_listu(prvi);

    return 0;
}
