#include <stdio.h>
#include <stdlib.h>

#define MAX_LINE 129

void copy_file(FILE *in, FILE *out)
{
    char buf[MAX_LINE];    /* Ulazni buffer. */

    while (fgets(buf, MAX_LINE, in) != NULL)
        if (fputs(buf, out) == EOF) {
            fprintf(stderr,
                    "\nGreska u pisanju.\n");
            exit(11);
        }

    if (ferror(in)) {
        fprintf(stderr, "\nGreska u citanju.\n");
        exit(12);
    }

    return;
}


int main(int argc, char *argv[])
{
    FILE *in, *out;

    if (argc != 3) {    /* nema imena datoteka! */
        fprintf(stderr, "Uporaba: %s ime1 ime2\n",
                argv[0]);
        exit(1);
    }

    if ((in = fopen(argv[1], "r")) == NULL) {
        fprintf(stderr, "Ne mogu citati: %s!\n",
                argv[1]);
        exit(2);
    }

    if ((out = fopen(argv[2], "w")) == NULL) {
        fprintf(stderr, "Ne mogu pisati: %s!\n",
                argv[2]);
        exit(3);
    }

    copy_file(in, out);

    fclose(in);
    fclose(out);

    return 0;
}
